//+------------------------------------------------------------------+
//|                                              GoldenFilter_v1.mq4 |
//|                                         Copyright  2007, madro  |
//|                                               madrofx@yahoo.com  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, madro"
#property  link      "madrofx@yahoo.com"
//----
#property indicator_separate_window    
#property indicator_buffers  8
#property indicator_minimum  0
#property indicator_maximum  1
#property indicator_color1 RoyalBlue
#property indicator_color2 OrangeRed
#property indicator_color3 Goldenrod
#property indicator_color4 DarkGray
#property indicator_color5 Goldenrod
#property indicator_color6 DarkGray
#property indicator_color7 Goldenrod
#property indicator_color8 Gray
//----
extern int FasterMA = 5;
extern int SlowerMA = 15;
extern int FasterMAType = 1;
extern int SlowerMAType = 1;
extern int MACD_Fast = 8;
extern int MACD_Slow = 17;
extern int MACD_Signal = 9; 
extern int RSI = 21;
extern int Momentum = 14;
extern int DeMarker = 14;
extern int ADX = 14;
extern int ForceIndex = 14;
extern bool comment    = true;
extern bool SoundAlert = true;

//---- indicator buffers
double MomUp[];
double MomDown[];
double TrendCrossUp[];
double TrendCrossDown[];
double TrendUp[];
double TrendDown[];
double MAcrossUp[];
double MAcrossDown[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
//---- indicator line
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0,120);
   SetIndexBuffer(0, MomUp);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1,120);
   SetIndexBuffer(1, MomDown);
   SetIndexLabel(0,"Mom("+Momentum+")>100 Up");//0.05   
   SetIndexLabel(1,"Mom("+Momentum+")<100 Dn");

   
   SetIndexStyle(2, DRAW_ARROW);  //DEM > 0.5 && FI >0 //0.22 
   SetIndexArrow(2, 110);
   SetIndexBuffer(2, TrendUp);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, 110);
   SetIndexBuffer(3, TrendDown);
   SetIndexLabel(2,"Dem>0.5 FI>0 TrendUp");//0.22  
   SetIndexLabel(3,"Dem<0.5 FI<0 TrendDn");
   
   SetIndexStyle(4, DRAW_ARROW); 
   SetIndexArrow(4, 251);
   SetIndexBuffer(4, TrendCrossUp);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, 251);
   SetIndexBuffer(5, TrendCrossDown);
   SetIndexLabel(4,"RSI MACD ADX |CrossUp");//0.47   
   SetIndexLabel(5,"RSI MACD ADX |CrossDn");

   
   SetIndexStyle(6, DRAW_ARROW,0,1); //0.8
   SetIndexArrow(6, 241);
   SetIndexBuffer(6, MAcrossUp);
   SetIndexStyle(7, DRAW_ARROW,0,1);
   SetIndexArrow(7, 242);
   SetIndexBuffer(7, MAcrossDown);
   SetIndexLabel(6,"Fast/Sl MA crossUp");//0.8
   SetIndexLabel(7,"Fast/Sl MA crossDn");

   
      
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName  ("Madro-9 ");

      if (comment)  
 Comment (" Madro-9:"+
 " :\n  MA("+FasterMA+") MA("+SlowerMA+") Cross"+ 
 "; \n  RSI("+RSI+") MACD ("+MACD_Fast+","+MACD_Slow+","+MACD_Signal+") ADX("+ADX+
 ");\n  Dem("+DeMarker+") FI("+ForceIndex+
 ");\n  Mom("+Momentum+ ").");


   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//|  GoldenFilter_v1                                                 |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   int i;
   int limit;
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {	
	    double  fasterMAnow  = iMA(NULL, 0, FasterMA, 0, FasterMAType, 
	                                PRICE_CLOSE, i);
       double  fasterMAprevious = iMA(NULL, 0, FasterMA, 0, FasterMAType, 
                                      PRICE_CLOSE, i + 1);
       double  fasterMAafter = iMA(NULL, 0, FasterMA, 0, FasterMAType, 
                                   PRICE_CLOSE, i - 1);
       double  slowerMAnow = iMA(NULL, 0, SlowerMA, 0, SlowerMAType, 
                                 PRICE_CLOSE, i);
       double  slowerMAprevious = iMA(NULL, 0, SlowerMA, 0, 
                                      SlowerMAType, PRICE_CLOSE, i + 1);
       double  slowerMAafter = iMA(NULL, 0, SlowerMA, 0, SlowerMAType, 
                                   PRICE_CLOSE, i - 1);
       //---- 
       double  MACD = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow, 
                            MACD_Signal, PRICE_CLOSE, MODE_MAIN, i);
       double  MACD_Sig = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow,
                                MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, i);
       //---- 
       double  ADX1 = iADX(NULL, 0, ADX, PRICE_CLOSE, MODE_PLUSDI, i);
       double  ADX2 = iADX(NULL, 0, ADX, PRICE_CLOSE, MODE_MINUSDI, i);
       //----
       double  RSIV = iRSI(NULL, 0, RSI, 0, i);
       
       double  DEM = iDeMarker(NULL, 0, DeMarker, i); 
       double  FI = iForce(NULL, 0, ForceIndex, 1, PRICE_CLOSE, i);
 
       double  MOM = iMomentum( NULL,0, Momentum, PRICE_CLOSE, i); 
	 	 
	 	 if(MOM > 100) 
           MomUp[i] = 0.05;
       if(MOM <= 100) 
           MomDown[i] = 0.05;
       
       if(DEM > 0.5 && FI >0)
           TrendUp[i] = 0.22;
       if(DEM < 0.5 < 50 && FI < 0)
           TrendDown[i] = 0.22;         
       
       if(RSIV > 50 && MACD > MACD_Sig && ADX1 > ADX2)
           TrendCrossUp[i] = 0.47;
       if(RSIV < 50 && MACD < MACD_Sig && ADX1 < ADX2)
           TrendCrossDown[i] = 0.47; 


     static datetime lastalertUp=0,lastalertDn=0;

       if((fasterMAnow > slowerMAnow) && 
          (fasterMAprevious < slowerMAprevious) && 
          (fasterMAafter > slowerMAafter))
         {
           MAcrossUp[i] = 0.75;
           if(SoundAlert == true && lastalertUp!=Time[0])
             {
               Alert("GoldenMadro MACrossUp " + Symbol() + " on the " + 
                     Period() + " minute chart.");
               lastalertUp=Time[0];

             }
         }
       if((fasterMAnow < (slowerMAnow)) && 
          (fasterMAprevious > (slowerMAprevious)) && 
          (fasterMAafter < slowerMAafter))  
         {
           MAcrossDown[i] = 0.7;
           if(SoundAlert == true && lastalertDn!=Time[0])
               Alert("GoldenMadro MACrossDown " + Symbol() + " on the " + 
                     Period() + " minute chart.");
               lastalertDn=Time[0];
 
         } 
       
     }  
   return(0);	
  }
//+------------------------------------------------------------------+



